// import { Component, Inject, OnInit, PLATFORM_ID } from '@angular/core';
// import { isPlatformBrowser } from '@angular/common';
// import { EChartsOption } from 'echarts';
// import { BsModalService, BsModalRef } from 'ngx-bootstrap/modal';
// import { ModalContentComponent } from './modal-content/modal-content.component';

// @Component({
//   selector: 'app-root',
//   templateUrl: './app.component.html',
//   styleUrls: ['./app.component.css'],
// })
// export class AppComponent implements OnInit {
//   chartOption: EChartsOption | null = null;

//   drillDownChartOption: EChartsOption | null = null;
//   modalRef!: BsModalRef;

//   data: any[] = [
//     {
//       name: 'Fruits',
//       total: 300,
//       drilldown: [
//         { name: 'Apples', value: 120 },
//         { name: 'Oranges', value: 80 },
//         { name: 'Bananas', value: 100 },
//       ],
//     },
//     {
//       name: 'Vegetables',
//       total: 200,
//       drilldown: [
//         { name: 'Tomatoes', value: 90 },
//         { name: 'Peppers', value: 60 },
//         { name: 'Carrots', value: 50 },
//       ],
//     },
//   ];

//   constructor(
//     @Inject(PLATFORM_ID) private platformId: Object,
//     private modalService: BsModalService
//   ) {}

//   ngOnInit(): void {
//     if (isPlatformBrowser(this.platformId)) {
//       this.chartOption = {
//         tooltip: {
//           trigger: 'axis',
//           axisPointer: { type: 'shadow' },
//         },
//         xAxis: {
//           type: 'category',
//           data: ['Item A', 'Item B', 'Item C', 'Item D', 'Item E', 'Item F'],
//         },
//         yAxis: { type: 'value' },
//         series: [{ data: [120, 200, 150, 100, 270, 180], type: 'bar' }],
//       };

//       this.setChartOptions(
//         this.data.map((item) => ({
//           name: item.name,
//           value: item.total,
//         }))
//       );
//     }
//   }

//   onChartClick(event: any): void {
//     const itemData = event.seriesName;
//     // Data for the modal can be fetched or calculated here based on the itemData
//     this.openModalWithData(this.fetchDataForItem(itemData));
//   }

//   fetchDataForItem(itemName: string) {
//     // This is where you fetch or construct the data based on the bar clicked
//     return [
//       { attribute: 'Detail 1', value: 'Data A' },
//       { attribute: 'Detail 2', value: 'Data B' },
//       { attribute: 'Detail 3', value: 'Data C' },
//       { attribute: 'Detail 4', value: 'Data A' },
//       { attribute: 'Detail 5', value: 'Data B' },
//       { attribute: 'Detail 6', value: 'Data C' },
//     ];
//   }

//   openModalWithData(data: any): void {
//     const initialState = { list: data };
//     this.modalRef = this.modalService.show(ModalContentComponent, {
//       initialState,
//     });
//     this.modalRef.content.closeBtnName = 'Close';
//   }

//   //----------------------------------------------------------------
//   setChartOptions(data: any[]): void {
//     this.drillDownChartOption = {
//       tooltip: {
//         trigger: 'item',
//         formatter: '{a} <br/>{b} : {c}',
//       },
//       xAxis: {
//         type: 'category',
//         data: data.map((item) => item.name),
//       },
//       yAxis: {
//         type: 'value',
//       },
//       series: [
//         {
//           name: 'Categories',
//           type: 'bar',
//           data: data,
//           label: {
//             show: true,
//             position: 'inside',
//           },
//         },
//       ],
//     };
//   }

//   onDrillDownChartClick(event: any): void {
//     const selectedItem = this.data.find((item) => item.name === event.name);
//     if (selectedItem && selectedItem.drilldown) {
//       this.setChartOptions(selectedItem.drilldown);
//     }
//   }
// }

//----------------------------------------------------------------Echarts Drill Down ----------------------------------------------------------------
// import { Component, Inject, OnInit, PLATFORM_ID } from '@angular/core';
// import { isPlatformBrowser } from '@angular/common';
// import { EChartsOption } from 'echarts';
// import { BsModalService, BsModalRef } from 'ngx-bootstrap/modal';
// import { ModalContentComponent } from './modal-content/modal-content.component';

// @Component({
//   selector: 'app-root',
//   templateUrl: './app.component.html',
//   styleUrls: ['./app.component.css'],
// })
// export class AppComponent implements OnInit {
//   chartOption: EChartsOption | null = null;
//   drillDownChartOption: EChartsOption | null = null;
//   modalRef!: BsModalRef;

//   data: any[] = [
//     {
//       name: 'Fruits',
//       total: 300,
//       drilldown: [
//         { name: 'Apples', value: 120 },
//         { name: 'Oranges', value: 80 },
//         { name: 'Bananas', value: 100 },
//       ],
//     },
//     {
//       name: 'Vegetables',
//       total: 200,
//       drilldown: [
//         { name: 'Tomatoes', value: 90 },
//         { name: 'Peppers', value: 60 },
//         { name: 'Carrots', value: 50 },
//       ],
//     },
//     {
//       name: 'Dairy',
//       total: 150,
//       drilldown: [
//         { name: 'Milk', value: 70 },
//         { name: 'Cheese', value: 80 },
//       ],
//     },
//     {
//       name: 'Ornaments',
//       total: 250,
//       drilldown: [
//         { name: 'Gold', value: 150 },
//         { name: 'Silver', value: 100 },
//       ],
//     },
//     {
//       name: 'Beverages',
//       total: 180,
//       drilldown: [
//         { name: 'Coffee', value: 100 },
//         { name: 'Tea', value: 80 },
//       ],
//     },
//     {
//       name: 'Snacks',
//       total: 220,
//       drilldown: [
//         { name: 'Chips', value: 120 },
//         { name: 'Nuts', value: 100 },
//       ],
//     },
//   ];

//   constructor(
//     @Inject(PLATFORM_ID) private platformId: Object,
//     private modalService: BsModalService
//   ) {}

//   ngOnInit(): void {
//     if (isPlatformBrowser(this.platformId)) {
//       this.setMainChartOptions();
//     }
//   }

//   setMainChartOptions(): void {
//     this.chartOption = {
//       title: {
//         text: 'Drilldown Bar Chart',
//         left: 'center', // Center align the title
//         textStyle: {
//           fontWeight: 'bold', // Make title text bold
//           fontSize: 18, // Increase the font size
//         },
//       },
//       tooltip: {
//         trigger: 'axis',
//         axisPointer: { type: 'shadow' },
//       },
//       xAxis: {
//         type: 'category',
//         data: this.data.map((item) => item.name),
//         name: 'Category Types',
//         nameTextStyle: {
//           fontWeight: 'bold', // Make x-axis label bold
//           fontSize: 16, // Increase the font size
//         },
//         nameLocation: 'middle', // Centers the axis name
//         nameGap: 30, // Increase gap to position the name better
//       },
//       yAxis: {
//         type: 'value',
//         name: 'Bar Chart',
//         nameTextStyle: {
//           fontWeight: 'bold', // Make y-axis label bold
//           fontSize: 16, // Increase the font size
//         },
//         nameLocation: 'middle', // Centers the axis name
//         nameRotate: 90, // Rotate to align vertically
//         nameGap: 50, // Adjust gap to avoid clipping with axis labels
//       },
//       series: [
//         {
//           name: 'Categories',
//           type: 'bar',
//           data: this.data.map((item) => ({
//             name: item.name,
//             value: item.total,
//           })),
//           label: {
//             show: true,
//             position: 'inside',
//           },
//         },
//       ],
//     };
//     this.drillDownChartOption = null; // Initially hide the drilldown chart
//   }

//   onChartClick(event: any): void {
//     const selectedItem = this.data.find((item) => item.name === event.name);
//     if (selectedItem && selectedItem.drilldown) {
//       this.setDrillDownChartOptions(selectedItem.drilldown);
//     }
//   }

//   setDrillDownChartOptions(drilldownData: any[]): void {
//     this.drillDownChartOption = {
//       tooltip: {
//         trigger: 'item',
//         formatter: '{a} <br/>{b} : {c}',
//       },
//       xAxis: {
//         type: 'category',
//         data: drilldownData.map((item) => item.name),
//       },
//       yAxis: {
//         type: 'value',
//       },
//       series: [
//         {
//           name: 'Details',
//           type: 'bar',
//           data: drilldownData,
//           label: {
//             show: true,
//             position: 'inside',
//           },
//         },
//       ],
//     };
//     this.chartOption = null; // Optionally hide the main chart when displaying the drilldown
//   }

//   onDrillDownChartClick(event: any): void {
//     // Handle click on the drilldown chart (e.g., navigating back to the main chart)
//     this.setMainChartOptions(); // This will show the main chart again
//   }
// }

import {
  Component,
  OnInit,
  OnDestroy,
  NgZone,
  ViewChild,
  ElementRef,
  PLATFORM_ID,
  Inject,
} from '@angular/core';
import { isPlatformBrowser } from '@angular/common';
import * as am4core from '@amcharts/amcharts4/core';
import * as am4charts from '@amcharts/amcharts4/charts';
import am4themes_animated from '@amcharts/amcharts4/themes/animated';

interface ChartData {
  category: string;
  value: number;
  subData?: ChartData[]; // Optional because not all items may have subdata
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
})
export class AppComponent implements OnInit, OnDestroy {
  private chart!: am4charts.XYChart;
  private dataHistory: ChartData[][] = []; // Stack to keep track of data states

  constructor(
    private zone: NgZone,
    @Inject(PLATFORM_ID) private platformId: Object
  ) {}

  ngOnInit(): void {
    if (isPlatformBrowser(this.platformId)) {
    }
  }

  ngAfterViewInit() {
    if (isPlatformBrowser(this.platformId)) {
    }
    this.zone.runOutsideAngular(() => {
      am4core.useTheme(am4themes_animated);

      let chart = am4core.create('chartdiv', am4charts.XYChart);
      chart.hiddenState.properties.opacity = 0; // this creates initial fade-in

      chart.data = [
        {
          category: 'Fruits',
          value: 300,
          subData: [
            { category: 'Apples', value: 120, color: am4core.color('#845EC2') },
            { category: 'Oranges', value: 80, color: am4core.color('#D65DB1') },
            {
              category: 'Bananas',
              value: 100,
              color: am4core.color('#FF6F91'),
            },
          ],
        },
        {
          category: 'Vegetables',
          value: 250,
          subData: [
            { category: 'Tomatoes', value: 100 },
            { category: 'Peppers', value: 80 },
            { category: 'Carrots', value: 70 },
          ],
        },
        {
          category: 'Grains',
          value: 180,
          subData: [
            { category: 'Rice', value: 90 },
            { category: 'Oats', value: 60 },
            { category: 'Quinoa', value: 30 },
          ],
        },
        {
          category: 'Legumes',
          value: 220,
          subData: [
            { category: 'Lentils', value: 110 },
            { category: 'Chickpeas', value: 70 },
            { category: 'Black Beans', value: 40 },
          ],
        },
        {
          category: 'Nuts and Seeds',
          value: 150,
          subData: [
            { category: 'Almonds', value: 60 },
            { category: 'Cashews', value: 50 },
            { category: 'Flax Seeds', value: 40 },
          ],
        },
        {
          category: 'Herbs and Spices',
          value: 120,
          subData: [
            { category: 'Basil', value: 50 },
            { category: 'Turmeric', value: 40 },
            { category: 'Cinnamon', value: 30 },
          ],
        },
        {
          category: 'Dairy Alternatives',
          value: 180,
          subData: [
            { category: 'Almond Milk', value: 80 },
            { category: 'Soy Milk', value: 60 },
            { category: 'Coconut Yogurt', value: 40 },
          ],
        },
        {
          category: 'Beverages',
          value: 160,
          subData: [
            { category: 'Tea', value: 90 },
            { category: 'Coffee', value: 40 },
            { category: 'Vegetable Juice', value: 30 },
          ],
        },
      ];

      let categoryAxis = chart.xAxes.push(new am4charts.CategoryAxis());
      categoryAxis.dataFields.category = 'category';
      categoryAxis.renderer.grid.template.location = 0;

      let valueAxis = chart.yAxes.push(new am4charts.ValueAxis());

      let series = chart.series.push(new am4charts.ColumnSeries());
      series.dataFields.valueY = 'value';
      series.dataFields.categoryX = 'category';
      series.columns.template.tooltipText = '{categoryX}: [bold]{valueY}[/]';
      series.columns.template.fillOpacity = 0.8;

      let columnTemplate = series.columns.template;
      columnTemplate.strokeWidth = 2;
      columnTemplate.strokeOpacity = 1;

      // Add title
      let title = chart.titles.create();
      title.text = 'Amcharts Drill down bar chart';
      title.fontSize = 20;
      title.marginBottom = 20;
      title.align = 'center';

      // Optionally, add a back button to return to main data
      let backButton = chart.createChild(am4core.Button);
      // Assuming backButton is an instance of am4core.Button
      backButton.label!.text = 'Back'; // Using non-null assertion operator

      backButton.align = 'right';
      backButton.events.on('hit', () => {
        chart.data = [
          {
            category: 'Fruits',
            value: 300,
            subData: [
              {
                category: 'Apples',
                value: 120,
                color: am4core.color('#845EC2'),
              },
              {
                category: 'Oranges',
                value: 80,
                color: am4core.color('#D65DB1'),
              },
              {
                category: 'Bananas',
                value: 100,
                color: am4core.color('#FF6F91'),
              },
            ],
          },
          {
            category: 'Vegetables',
            value: 250,
            subData: [
              { category: 'Tomatoes', value: 100 },
              { category: 'Peppers', value: 80 },
              { category: 'Carrots', value: 70 },
            ],
          },
          {
            category: 'Grains',
            value: 180,
            subData: [
              { category: 'Rice', value: 90 },
              { category: 'Oats', value: 60 },
              { category: 'Quinoa', value: 30 },
            ],
          },
          {
            category: 'Legumes',
            value: 220,
            subData: [
              { category: 'Lentils', value: 110 },
              { category: 'Chickpeas', value: 70 },
              { category: 'Black Beans', value: 40 },
            ],
          },
          {
            category: 'Nuts and Seeds',
            value: 150,
            subData: [
              { category: 'Almonds', value: 60 },
              { category: 'Cashews', value: 50 },
              { category: 'Flax Seeds', value: 40 },
            ],
          },
          {
            category: 'Herbs and Spices',
            value: 120,
            subData: [
              { category: 'Basil', value: 50 },
              { category: 'Turmeric', value: 40 },
              { category: 'Cinnamon', value: 30 },
            ],
          },
          {
            category: 'Dairy Alternatives',
            value: 180,
            subData: [
              { category: 'Almond Milk', value: 80 },
              { category: 'Soy Milk', value: 60 },
              { category: 'Coconut Yogurt', value: 40 },
            ],
          },
          {
            category: 'Beverages',
            value: 160,
            subData: [
              { category: 'Tea', value: 90 },
              { category: 'Coffee', value: 40 },
              { category: 'Vegetable Juice', value: 30 },
            ],
          },
        ];
        categoryAxis.dataFields.category = 'category';
      });

      series.columns.template.events.on('hit', (ev) => {
        // let data = ev.target.dataItem.dataContext['subData'];
        // let data = ev.target.dataItem?.dataContext as any;
        // if (data) {
        //   chart.data = data;
        // }
        let data = ev.target.dataItem?.dataContext as ChartData;
        if (data && data.subData) {
          chart.data = data.subData;
          categoryAxis.dataFields.category = 'category';
          series.dataFields.valueY = 'value';
          series.dataFields.categoryX = 'category';
          series.columns.template.propertyFields.fill = 'D65DB1'; // Ensure the color property is used
        }
      });

      this.chart = chart;
    });
  }

  // ngOnDestroy() {
  //   this.zone.runOutsideAngular(() => {
  //     if (this.chart) {
  //       this.chart.dispose();
  //     }
  //   });
  // }
  ngOnDestroy(): void {
    this.zone.runOutsideAngular(() => {
      if (this.chart) {
        this.chart.dispose();
      }
    });
  }
}
